/*
 * KurzyTXT.java
 *
 * Created on 16. kvten 2004, 23:20
 */

package cz.vse.xkucf03.cnb;


import java.io.*;
import java.net.*;
/**
 *Tato tda slou k zskn aktulnch informac o mnovch kurzech z webu esk nrodn banky
 *Zkladem je metoda getKurz(), jejm parametrem je etzec nap. "USA", kter vrac kurz dan mny
 *a esk koruny jako float.
 *
 * @author  x
 */
public class KurzyTXT {
    
    String[] radky = new String[50]; //Soubor z webu nateme po dcch do pole
    String r; //bude vybrn jeden vyhovujc dek
    String[] p; //tento dek bude rozsekn - 4. hodnota je kurz, 2. hodnota je nsebek (nap. 100 jen)
    boolean pripojen = true;
    
    public static final String KOD_USD = "USA";
    
    /**vytvo instanci a nate soubor s daty*/
    public KurzyTXT() {
        aktualizuj();
    }

  
    
    /**Vrac kurz mny dan zem - pesn nzvy zem viz .txt soubor*/
    public float getKurz(String mena){
        if (pripojen){
            for (int i = 0; i < radky.length; i ++) {
                if (radky[i] != null) {
                    if (radky[i].startsWith(mena)){
                        radky[i] = radky[i].replace('|', '@');
                        radky[i] = radky[i].replace(',', '.');
                        p = radky[i].split("@");
                    }
                }
            }
            
            return Float.valueOf(p[4]).floatValue() / Float.valueOf(p[2]).floatValue();
        }
        else{
            return 0;
        }
    }
    
    /**testovac metoda*/
    public static void main(java.lang.String[] args) {
        KurzyTXT k = new KurzyTXT();
        System.out.println("Kurzy jsou aktln k datu: " + k.getDatum());
        System.out.println("Kurz dolaru: " + k.getKurz(KOD_USD));
        System.out.println("Kolik dolar za 400 K: " + k.prevedNaCizi(KOD_USD, 400));
        System.out.println("Kolik korun za 100 dolar: " + k.prevedNaKc(KOD_USD, 100));
        System.out.println("Kolik dolar za 400 K: " + k.prevedNaCiziR(KOD_USD, 400, "$ ", " USD"));
        System.out.println("Kolik korun za 100 dolar: " + k.prevedNaKcR(KOD_USD, 100, "", " K"));
        System.out.println("Kurz dolaru: " + k.prevedNaCizi(KOD_USD, k.prevedNaKc(KOD_USD, 100)));
    }
    
    /**Pevede hodnotu v K na ciz mnu, vrt slo float*/
    public float prevedNaCizi(java.lang.String mena, float koruny) {
        if (pripojen) {
            return koruny / getKurz(mena);
        }
        else {
            return 0;
        }
    }
    
    /**Pevede hodnotu v ciz mn na K, vrt slo float*/
    public float prevedNaKc(java.lang.String mena, float cizi) {
        if (pripojen) {
            return cizi * getKurz(mena);
        }
        else{
            return 0;
        }
    }
    
    /**Pevede hodnotu v K na ciz mnu, vrt etzec, na jedo zatek a konec pid zadan etzce "pred" a "za"*/
    public String prevedNaCiziR(java.lang.String mena, float koruny, String pred, String za) {
        if (pripojen) {
            return (pred + String.valueOf(koruny / getKurz(mena)).replace('.', ',') + za);
            
        }
        else{
            return "Chyba spojen";
        }
    }
    
    /**Pevede hodnotu v ciz mn na K, vrt etzec, na zatek a na konec pid zadan etzce "pred" a "za"*/
    public String prevedNaKcR(java.lang.String mena, float cizi, String pred, String za) {
        if (pripojen) {
            return (pred + String.valueOf(cizi * getKurz(mena)).replace('.', ',') + za);
        }
        else{
            return "Chyba spojen";
        }
    }
    
    /** Vrac true, pokud byl soubor s daty spn naten */
    public boolean isPripojen() {
        return pripojen;
    }
    
    /** Nate znovu soubor s kurzy z www NB */
    public void aktualizuj() {
        
        int i = 0; //ta pro jednotliv dky
        try {
            
            BufferedReader vstup = new BufferedReader(new InputStreamReader((new URL("http://wdb.cnb.cz/CNB_TXT/KURZY.K_CURRTXT")).openStream()));
            //BufferedReader vstup = new BufferedReader(new FileReader("c:/java/zdroje/cz/vse/xkucf03/cnb/kurzy.txt"));
            while ((r = vstup.readLine()) != null) {
                
                r = r.replace('|', '@');
                r = r.replace(',', '.');
                radky[i] = r;
                i++;
                
                
                
            }
            vstup.close();
        }
        catch (IOException e){
            System.out.println("Chyba na vstupu souboru");
            System.out.println(e);
            pripojen = false;
            
        }
        
    }
    
    /** Vrac datum aktualizace souboru s daty */
    public String getDatum() {
        return radky[0];
    }
    
    
    
}
